package net.nevet5gi.buzzbot.commands;

import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.database.SqlDB;
import net.nevet5gi.buzzbot.util.GuildUtils;

import java.util.List;

public class UnbanCmd implements ICommand {
    @Override
    public void handle(CommandContext ctx) {
        // Somehow keep track of bans
        // Make sure a user can only be unbanned from the guild they were banned from

        List<String> args = ctx.getArgs();

        long userId;
        if (args.get(0).contains("<@")) {
            userId = Long.parseLong(args.get(0).replace("<","").replace("@","").replace("&","").replace(">",""));
        } else {
            userId = Long.parseLong(args.get(0));
        }

        SqlDB sql = new SqlDB();
        sql.queryBan(userId, GuildUtils.getTable(ctx.getGuild()));
        sql.close();

        ctx.getGuild().getIdLong();
    }

    @Override
    public String getName() {
        return "unban";
    }

    @Override
    public int getPermissionLevel() {
        return 3;
    }

    @Override
    public String getHelp() {
        return "Unbans the specified user";
    }
}
