package net.nevet5gi.buzzbot.commands;

import net.nevet5gi.buzzbot.Bot;
import net.nevet5gi.buzzbot.commands.utils.CommandContext;
import net.nevet5gi.buzzbot.commands.utils.ICommand;
import net.nevet5gi.buzzbot.database.SqlDB;
import net.nevet5gi.buzzbot.objects.WarnData;

import java.util.List;

public class WarnCmd implements ICommand {
    @Override
    public void handle(CommandContext ctx) {
        List<String> args = ctx.getArgs();

        if (args.size() < 2) {
            ctx.getChannel().sendMessage("Not enough arguments, please try again").queue();
            return;
        }

        WarnData warn = new WarnData();

        if (args.get(0).contains("<@")) {
            warn.setUserId(Long.parseLong(args.get(0).replace("<","").replace("@","").replace("&","").replace(">","")));
        } else {
            warn.setUserId(Long.parseLong(args.get(0)));
        }

        StringBuilder sb = new StringBuilder();
        if (args.size() >= 1) {
            for (int i = 1; i < args.size(); i++) {
                sb.append(args.get(i));
                sb.append(" ");
            }
        }
        warn.setReason(sb.toString().trim());

        ctx.getChannel().sendMessage("<@" + ctx.getMessage().getAuthor().getId() + "> warned <@" + warn.getUserId() + "> for reason: " + warn.getReason()).queue();

        Bot.jda.retrieveUserById(warn.getUserId()).queue(user -> { warn.setUserName(user.getName()); });
        warn.setModId(ctx.getMessage().getAuthor().getIdLong());
        warn.setModName(ctx.getMessage().getAuthor().getName());
        warn.setServerId(ctx.getGuild().getIdLong());
        warn.setServerName(ctx.getGuild().getName());

        SqlDB sql = new SqlDB();
        sql.insertWarn(warn, "master_warn_record");
        sql.close();
    }

    @Override
    public String getName() {
        return "warn";
    }

    @Override
    public int getPermissionLevel() {
        return 2;
    }

    @Override
    public String getHelp() {
        return "Warns the specified user";
    }
}
